<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SiteResult StructType
 * @subpackage Structs
 */
class SiteResult extends AbstractStructBase
{
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - choice: Error | Site
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \StructType\ErrorInfo
     */
    public $Error;
    /**
     * The Site
     * Meta information extracted from the WSDL
     * - choice: Error | Site
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Site
     */
    public $Site;
    /**
     * The Door
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Door[]
     */
    public $Door;
    /**
     * The DoorGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DoorGroup[]
     */
    public $DoorGroup;
    /**
     * Constructor method for SiteResult
     * @uses SiteResult::setError()
     * @uses SiteResult::setSite()
     * @uses SiteResult::setDoor()
     * @uses SiteResult::setDoorGroup()
     * @param \StructType\ErrorInfo $error
     * @param \StructType\Site $site
     * @param \StructType\Door[] $door
     * @param \StructType\DoorGroup[] $doorGroup
     */
    public function __construct(\StructType\ErrorInfo $error = null, \StructType\Site $site = null, array $door = array(), array $doorGroup = array())
    {
        $this
            ->setError($error)
            ->setSite($site)
            ->setDoor($door)
            ->setDoorGroup($doorGroup);
    }
    /**
     * Get Error value
     * @return \StructType\ErrorInfo|null
     */
    public function getError()
    {
        return isset($this->Error) ? $this->Error : null;
    }
    /**
     * This method is responsible for validating the value passed to the setError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setError method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateErrorForChoiceConstraintsFromSetError($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Site',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Error can\'t be set as the property %s is already set. Only one property must be set among these properties: Error, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Error value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorInfo $error
     * @return \StructType\SiteResult
     */
    public function setError(\StructType\ErrorInfo $error = null)
    {
        // validation for constraint: choice(Error, Site)
        if ('' !== ($errorChoiceErrorMessage = self::validateErrorForChoiceConstraintsFromSetError($error))) {
            throw new \InvalidArgumentException($errorChoiceErrorMessage, __LINE__);
        }
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->Error);
        } else {
            $this->Error = $error;
        }
        return $this;
    }
    /**
     * Get Site value
     * @return \StructType\Site|null
     */
    public function getSite()
    {
        return isset($this->Site) ? $this->Site : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSite method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSite method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSiteForChoiceConstraintsFromSetSite($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Error',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Site can\'t be set as the property %s is already set. Only one property must be set among these properties: Site, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Site value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Site $site
     * @return \StructType\SiteResult
     */
    public function setSite(\StructType\Site $site = null)
    {
        // validation for constraint: choice(Error, Site)
        if ('' !== ($siteChoiceErrorMessage = self::validateSiteForChoiceConstraintsFromSetSite($site))) {
            throw new \InvalidArgumentException($siteChoiceErrorMessage, __LINE__);
        }
        if (is_null($site) || (is_array($site) && empty($site))) {
            unset($this->Site);
        } else {
            $this->Site = $site;
        }
        return $this;
    }
    /**
     * Get Door value
     * @return \StructType\Door[]|null
     */
    public function getDoor()
    {
        return $this->Door;
    }
    /**
     * This method is responsible for validating the values passed to the setDoor method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDoor method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDoorForArrayConstraintsFromSetDoor(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $siteResultDoorItem) {
            // validation for constraint: itemType
            if (!$siteResultDoorItem instanceof \StructType\Door) {
                $invalidValues[] = is_object($siteResultDoorItem) ? get_class($siteResultDoorItem) : sprintf('%s(%s)', gettype($siteResultDoorItem), var_export($siteResultDoorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Door property can only contain items of type \StructType\Door, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Door value
     * @throws \InvalidArgumentException
     * @param \StructType\Door[] $door
     * @return \StructType\SiteResult
     */
    public function setDoor(array $door = array())
    {
        // validation for constraint: array
        if ('' !== ($doorArrayErrorMessage = self::validateDoorForArrayConstraintsFromSetDoor($door))) {
            throw new \InvalidArgumentException($doorArrayErrorMessage, __LINE__);
        }
        $this->Door = $door;
        return $this;
    }
    /**
     * Add item to Door value
     * @throws \InvalidArgumentException
     * @param \StructType\Door $item
     * @return \StructType\SiteResult
     */
    public function addToDoor(\StructType\Door $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Door) {
            throw new \InvalidArgumentException(sprintf('The Door property can only contain items of type \StructType\Door, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Door[] = $item;
        return $this;
    }
    /**
     * Get DoorGroup value
     * @return \StructType\DoorGroup[]|null
     */
    public function getDoorGroup()
    {
        return $this->DoorGroup;
    }
    /**
     * This method is responsible for validating the values passed to the setDoorGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDoorGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDoorGroupForArrayConstraintsFromSetDoorGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $siteResultDoorGroupItem) {
            // validation for constraint: itemType
            if (!$siteResultDoorGroupItem instanceof \StructType\DoorGroup) {
                $invalidValues[] = is_object($siteResultDoorGroupItem) ? get_class($siteResultDoorGroupItem) : sprintf('%s(%s)', gettype($siteResultDoorGroupItem), var_export($siteResultDoorGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DoorGroup property can only contain items of type \StructType\DoorGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DoorGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\DoorGroup[] $doorGroup
     * @return \StructType\SiteResult
     */
    public function setDoorGroup(array $doorGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($doorGroupArrayErrorMessage = self::validateDoorGroupForArrayConstraintsFromSetDoorGroup($doorGroup))) {
            throw new \InvalidArgumentException($doorGroupArrayErrorMessage, __LINE__);
        }
        $this->DoorGroup = $doorGroup;
        return $this;
    }
    /**
     * Add item to DoorGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\DoorGroup $item
     * @return \StructType\SiteResult
     */
    public function addToDoorGroup(\StructType\DoorGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DoorGroup) {
            throw new \InvalidArgumentException(sprintf('The DoorGroup property can only contain items of type \StructType\DoorGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DoorGroup[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SiteResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
